<template>
  <div class="row card-binding">
    <!--Подгружаем стандарную привязку карты без проверки ее на 3DS>-->

    <card-building :column="'six'"
                   v-if="loanType === 1"
                   :type="loanType"
                   ref="card"
                   @resultSuccess="resultSuccess"
                   @resultError="resultError" @enter="$refs.card.getAnswer()">
    </card-building>

    <!--Сценарий, когда карту необходимо привязать и подтвердить через 3DS-->
    <div v-else>
      <!--Левая сторона карты-->

      <card-building class="columns six" :type="loanType" ref="card" @resultTDS="resultTDS" @cardData="cardData" :blocker="blocker"  @resultError="resultError" @enter="$refs.card.getAnswer()"></card-building>
      <!-- Правая сторона карты -->
      <!--Выводим банковскую карту и проверяем на 3DS-->
      <div class="columns six block-acceptance_card-top" v-if="!form_tds">
        <div class="acceptance__card">
          <div class="acceptance__card-wrapper">
            <!--<SVGIcon class="acceptance__card-icon"/>-->
            <div class="acceptance__card-icon">
              <SVGIcon :xlink="bank.id + '-full'"
                       :viewBox="bank.size"
              />
            </div>
            <div class="acceptance__card-number-1">{{series[0]}}</div>
            <div class="acceptance__card-number-2">{{series[1]}}</div>
            <div class="acceptance__card-number-3">{{series[2]}}</div>
            <div class="acceptance__card-number-4" :style="{width: sizeColumn + 'px'}">{{series[3]}}</div>
            <div class="acceptance__card-name">{{double_card.holder}}</div>
            <div class="acceptance__card-cvc">{{double_card.month}}{{double_card.month.length > 1 ? '/' : ''}}{{double_card.year}}</div>
          </div>
        </div>

        <div class="acceptance__card__block-info">
          <p class="acceptance__sub-card-title">Вы можете получить займ прямо на карту в течение 10 минут. Это cамый
          быстрый и безопасный способ!</p>

          <button class="acceptance__sub-card-button button red"
                  :disabled="$interface.buttonLoading"
                  @click="$refs.card.getAnswer(); blocker = true"
          >
            <!--@click="postCardData"-->
            Добавить карту
          </button>

          <Checkbox v-model="consent" @input="BUTTON_LOADING(consent = !consent)" id="checkbox-table">
            <template slot="label-slot">
              Согласен с привязкой карты <a class="link" target="_blank" href="https://static.webbankir.com/public/docs/regulations.pdf?_ga=2.181938727.1026974616.1550061337-200762529.1535630714">и условиями списания</a>.
            </template>
          </Checkbox>
        </div>

      </div>

      <!--Форма в случае, если 3DS не был подтвержден-->

      <div class="columns six right-block-acceptance_card-top" v-if="form_tds">
        <Without3DS :line_left="true"
                    @cancel_building="form_tds = false; blocker = false"
                    :id="id"
                    :numberCard="numberCard"
                    @resultSuccess="resultSuccess"
        />
      </div>


      <div class="acceptance__footer">
        <div class="acceptance__footer-icons">
          <SVGIcon class="acceptance__footer-icons-icon"
                   v-for="item in footerSecureIcons"
                   :key="item.xlink"
                   :xlink="item.xlink"
                   :viewBox="item.viewBox"
          />
        </div>
        <div class="acceptance__footer-secure">
          <SVGIcon class="acceptance__footer-secure-icon"
                   xlink="lock"
                   viewBox="0 0 20 20"/>
          <p class="acceptance__footer-secure-title">Безопасное соединение</p>
        </div>
      </div>

      <!--Форма для работы с TDS-формой в виде модалки-->

      <modal name="tds-frame-modal"
             class="arcticmodal-container full-viewport"
             width="600"
             height="auto"
             :show="true"
             :adaptive=true
             :clickToClose="false"
             @before-open="$helpers.noscroll(true)"
             @before-close="$helpers.noscroll(false)"
      >
        <div class="popup">
          <div class="popup__wrapper">
            <div class="popup__header popup__header-with-back">
              <div class="popup__back" @click="closeModal">
                <SVGIcon xlink="next-arrow-20" viewBox="0 0 20 20" :rotate="180"/>
              </div>
              <h3 class="popup__header-title">Подтверждение привязки карты</h3>
            </div>
            <div class="popup__content my-accounts-modal1">
              <div class="row" style="position: relative">
                <Form3DS v-if="Object.keys(formData).length"
                         :formData="formData"
                         @clearFormData="clearFormData"
                         @resultSuccess="resultSuccess"
                />
              </div>
            </div>
          </div>
        </div>
      </modal>

    </div>
  </div>

</template>

<script>
  import Multiselect from '@/UI/Multiselect'
  import VuexErrorBlock from '@/components/Validators/VuexErrorBlock'
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import CardBuilding from '@/components/CardBuilding'
  import SVGIcon from "@/components/SVGIcon";
  import Checkbox from '@/components/Checkbox';
  import Without3DS from '@/components/CardBuilding/TDS/Without3DS';
  import Form3DS from '@/components/CardBuilding/TDS/Form3DS';
  import {nameBank} from '@/helpers/bin-banks'

export default {
    name: 'new-account-card',
    components: {
      Form3DS,
      VuexErrorBlock,
      CardBuilding,
      Multiselect,
      SVGIcon,
      Checkbox,
      Without3DS
    },
    mixins: [ErrorHandleMixin],
    props: {
      sum: {
        default: 0
      }
    },
    data () {
      return {
        id: '',
        numberCard: '',
        formData: {},
        form_tds: false,
        consent: true,
        bank: {
          id: 'unknownbank',
          name: '',
          size: '-35 0 101 30'
        },
        series: [],
        double_card: {
          month: '',
          year: '',
          holder: ''
        },
        blocker: false, // необходима для блокировки полей
        // footer of form
        footerSecureIcons: [{
          xlink: 'verified-by-visa',
          viewBox: '0 0 65 40'
        }, {
          xlink: 'master-card-secure-code',
          viewBox: '0 0 85 40'
        }, {
          xlink: 'mir-accept',
          viewBox: '0 0 75 40'
        }, {
          xlink: 'pci-dss',
          viewBox: '0 0 80 40'
        }]
      }
    },
    computed: {
        loanType () {
            if ([2, 3].includes(this.$config.newCard)) {
              return 8;
            } else if (this.$config.newCard === 1 && this.sum > 20000) {
              return 8;
            } else {
              return 1
            }
            // return this.sum > 20000 ? 8 : 1; // @todo условие для привязки и обычных карт и токенизированных
        },
        sizeColumn () {
            if (this.series[3]) {
                if (this.series[3].length === 4) {
                    return 46
                }
                if (this.series[3].length === 5) {
                    return 59
                }
                if (this.series[3].length === 6) {
                    return 69
                }
                if (this.series[3].length === 7) {
                    return 81
                }
            } else {
                return 46
            }
        }
    },
    watch: {
        'series' (number) {
            let type = number.join().replace(/,/g, '').slice(0,6);
            this.bank = nameBank(type)
        },
        'formData' (data) {
			if (Object.keys(data).length) {
				this.$modal.show('tds-frame-modal')
            } else {
				this.$modal.hide('tds-frame-modal')
            }
        }
    },
    methods: {
      resultTDS (tds) {
        if (tds?.data) { // если карта имеет TDS
          this.formData = tds.data;
        } else if (tds?.id) { // в случае, если у карты нету TDS
          this.id = tds.id;
          this.numberCard = tds.numberCard;
          this.form_tds = true
        } else { // в случае, если что то пошло не так или что то не пришло, обнуляем до исходного состояния
          this.form_tds = false;
        }
      },
      cardData ({numberCard, month, year, holder}) {
        this.series = numberCard.split('-');
        this.double_card.month = month;
        this.double_card.year = year;
        this.double_card.holder = holder;
      },
      resultSuccess (data) {
        this.$emit('resultSuccess', data);
        this.$modal.hide('tds-frame-modal');
		  this.blocker = false;

	  },
		resultError () {
      	this.blocker = false;
        },

      closeModal () {
		  this.$modal.hide('tds-frame-modal');
		  this.formData = {};
		  this.blocker = false
	  },
	  clearFormData () {
		  this.formData = {};
		  this.blocker = false;
      }
    }
  }
</script>

<style scoped>
  .cardImg {
    position: absolute;
    right: 6px;
    top: 48px;
  }
  /* .invalid-card {
    background-color: #fff0ed;
  }

  h3 {
    margin-bottom: 0px !important;
  }
  .buttons {
    text-align: center
  } */

  .block-acceptance_card-top {
    margin-top: -158px;
    padding-top: 75px;
    border-left: 1px solid #e9eff4;
  }
  .right-block-acceptance_card-top {
    margin-top: -141px;
  }

  .card-period {
    text-align: right;
    margin-bottom: 10px;
    color: #898989;
    font-size: 15px;
    font-weight: 400;
    padding-top: 50px;
}
  .acceptance__card {
    -webkit-box-shadow: 2px 2px 2px 3px rgba(224, 224, 224, 0.5);
    box-shadow: 2px 2px 2px 3px rgba(224, 224, 224, 0.5);
    margin: auto;
  }
  .acceptance__card__block-info {
    width: 310px;
    margin: auto;
    padding: 20px 0;
  }
  .acceptance__sub-card-title {
    margin: 28px 0;
  }
  .acceptance__footer {
    border-top: 1px solid #e9eff4;
  }

  @media (max-width: 1099px) {
    .login-page .card-binding .card-period {
      text-align: left;
      padding-top: 0px;
    }

    .login-page .card-binding .adaptive-col {
      width: 48%;
    }

    .login-page .card-binding .first-col {
      margin-right: 4%;
    }
    .block-acceptance_card-top {
      border-left: none;
      padding-top: 15px;
    }
    .block-acceptance_card-top, .right-block-acceptance_card-top {
      margin-top: 0;
    }
  }
</style>
